| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Private Member Functions | Private Attributes | List of all members
StatusCodeSvc Class Reference

`#include <src/StatusCodeSvc.h>`

Inheritance diagram for StatusCodeSvc:
[legend]
Collaboration diagram for StatusCodeSvc:
[legend]

## Classes
struct | StatCodeDat

## Public Member Functions
StatusCode | initialize () override
StatusCode | reinitialize () override
StatusCode | finalize () override
void | regFnc (const std::string &func, const std::string &lib) override
void | list () const override
bool | suppressCheck () const override
| StatusCodeSvc (const std::string &name, ISvcLocator *svc)
| ~StatusCodeSvc () override=default
Public Member Functions inherited from extends< Service, IStatusCodeSvc >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
StatusCode | setProperty (const Property &p) override
StatusCode | setProperty (const std::string &s) override
StatusCode | setProperty (const std::string &n, const std::string &v) override
StatusCode | getProperty (Property *p) const override
const Property & | getProperty (const std::string &name) const override
StatusCode | getProperty (const std::string &n, std::string &v) const override
const std::vector< Property * > & | getProperties () const override
bool | hasProperty (const std::string &name) const override
template<class TYPE >
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
Property * | declareProperty (const std::string &name, T &property, const std::string &doc="none") const
| Declare the named property. More...
Property * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="") const
| Declare remote named properties. More...
template<class T >
StatusCode | declarePrivateTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Private tool. More...
template<class T >
StatusCode | declarePublicTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Public tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces...>
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Private Member Functions
void | parseFilter (const std::string &str, std::string &fnc, std::string &lib)
void | filterFnc (const std::string &)
void | filterLib (const std::string &)

## Private Attributes
StringArrayProperty | m_pFilter
BooleanProperty | m_abort
BooleanProperty | m_suppress
BooleanProperty | m_dict
std::map< std::string, StatCodeDat > | m_dat
std::set< std::string > | m_filterfnc
std::set< std::string > | m_filterlib

## Additional Inherited Members
Public Types inherited from extends< Service, IStatusCodeSvc >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces...>
| Typedef to the base of this class. More...
Public Types inherited from Service
typedef Gaudi::PluginService::Factory< IService *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces...>
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids...>::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
IntegerProperty | m_outputLevel = MSG::NIL
| Service output level. More...
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...

## Detailed Description

Definition at line 12 of file StatusCodeSvc.h.

## Constructor & Destructor Documentation

StatusCodeSvc::StatusCodeSvc | ( | const std::string & | name,
|  | ISvcLocator * | svc
| ) |  |

Definition at line 16 of file StatusCodeSvc.cpp.

17 : base_class( name, svc )
18 {
19
20 declareProperty("Filter",m_pFilter);
21 declareProperty("AbortOnError",m_abort=false);
22 declareProperty("SuppressCheck", m_suppress=false);
23 declareProperty("IgnoreDicts",m_dict=true);
24
25 }
StatusCodeSvc::m_abort
BooleanProperty m_abort
Definition: StatusCodeSvc.h:43
StatusCodeSvc::m_dict
BooleanProperty m_dict
Definition: StatusCodeSvc.h:43
extends< Service, IStatusCodeSvc >::base_class
extends base_class
Typedef to this class.
Definition: extends.h:14
StatusCodeSvc::m_suppress
BooleanProperty m_suppress
Definition: StatusCodeSvc.h:43
StatusCodeSvc::m_pFilter
StringArrayProperty m_pFilter
Definition: StatusCodeSvc.h:42
Service::declareProperty
Property * declareProperty(const std::string &name, T &property, const std::string &doc="none") const
Declare the named property.
Definition: Service.h:215

StatusCodeSvc::~StatusCodeSvc | ( |  | ) |
| override default

## Member Function Documentation

void StatusCodeSvc::filterFnc | ( | const std::string & | str | ) |
| private

Definition at line 189 of file StatusCodeSvc.cpp.

189 {
190
191 auto itr = std::find_if(m_dat.begin(),m_dat.end(),
192 [&](const std::pair<std::string,StatCodeDat>& d) {
193 return d.second.fnc == str;
194 });
195 if (itr!=std::end(m_dat)) m_dat.erase(itr);
196
197 }
std::end
T end(T...args)
StatusCodeSvc::m_dat
std::map< std::string, StatCodeDat > m_dat
Definition: StatusCodeSvc.h:45
std::pair
std::find_if
T find_if(T...args)

void StatusCodeSvc::filterLib | ( | const std::string & | str | ) |
| private

Definition at line 201 of file StatusCodeSvc.cpp.

201 {
202
203 auto itr = std::find_if(m_dat.begin(),m_dat.end(),
204 [&](const std::pair<std::string,StatCodeDat>& d) {
205 return d.second.lib == str;
206 });
207 if (itr!=std::end(m_dat)) m_dat.erase(itr);
208 }
std::end
T end(T...args)
StatusCodeSvc::m_dat
std::map< std::string, StatCodeDat > m_dat
Definition: StatusCodeSvc.h:45
std::pair
std::find_if
T find_if(T...args)

StatusCode StatusCodeSvc::finalize | ( |  | ) |
| override

Definition at line 73 of file StatusCodeSvc.cpp.

73 {
74
75 if (!m_dat.empty()) {
76
77 info() << "listing all unchecked return codes:" << endmsg;
78
79 list();
80
81 } else {
82
83 if (msgLevel(MSG::DEBUG))
84 debug() << "all StatusCode instances where checked" << endmsg;
85
86 }
87
88 return StatusCode::SUCCESS;
89
90 }
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:124
MSG::DEBUG
Definition: IMessageSvc.h:18
StatusCodeSvc::list
void list() const override
Definition: StatusCodeSvc.cpp:153
StatusCodeSvc::m_dat
std::map< std::string, StatCodeDat > m_dat
Definition: StatusCodeSvc.h:45
StatusCode::SUCCESS
Definition: StatusCode.h:30
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:127
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:136
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

StatusCode StatusCodeSvc::initialize | ( |  | ) |
| override

Definition at line 31 of file StatusCodeSvc.cpp.

31 {
32
33 StatusCode sc = Service::initialize();
34 if (!sc.isSuccess()) return sc;
35
36 info() << "initialize" << endmsg;
37
38 for (const auto& itr : m_pFilter.value()) {
39 // we need to do this if someone has gotten to regFnc before initialize
40
41 string fnc,lib;
42 parseFilter(itr,fnc,lib);
43
44 if (!fnc.empty()) {
45 filterFnc(fnc);
46 m_filterfnc.insert(fnc);
47 }
48
49 if (!lib.empty()) {
50 filterLib(lib);
51 m_filterlib.insert(lib);
52 }
53
54 }
55
56 return StatusCode::SUCCESS;
57
58 }
Service::initialize
StatusCode initialize() override
Definition: Service.cpp:68
std::string::empty
T empty(T...args)
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:124
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:76
merge_files.sc
int sc
Definition: merge_files.py:167
StatusCodeSvc::parseFilter
void parseFilter(const std::string &str, std::string &fnc, std::string &lib)
Definition: StatusCodeSvc.cpp:213
StatusCode::SUCCESS
Definition: StatusCode.h:30
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
StatusCodeSvc::m_filterfnc
std::set< std::string > m_filterfnc
Definition: StatusCodeSvc.h:46
PropertyWithValue::value
const TYPE & value() const
explicit conversion
Definition: Property.h:341
std::set::insert
T insert(T...args)
StatusCodeSvc::m_pFilter
StringArrayProperty m_pFilter
Definition: StatusCodeSvc.h:42
StatusCodeSvc::filterLib
void filterLib(const std::string &)
Definition: StatusCodeSvc.cpp:201
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
StatusCodeSvc::filterFnc
void filterFnc(const std::string &)
Definition: StatusCodeSvc.cpp:189
StatusCodeSvc::m_filterlib
std::set< std::string > m_filterlib
Definition: StatusCodeSvc.h:46

void StatusCodeSvc::list | ( |  | ) | const
| override

Definition at line 153 of file StatusCodeSvc.cpp.

153 {
154
155
156
157 std::ostringstream os;
158 os << "Num | Function | Source Library" << endl;
159 os << "----+--------------------------------+-------------------"
160 << "-----------------------" << endl;
161
162 for(const auto& itr : m_dat) {
163 const auto& dat = itr.second;
164
165 os.width(3);
166 os.setf(ios_base::right,ios_base::adjustfield);
167 os << dat.count;
168
169 os << " | ";
170 os.width(30);
171 os.setf(ios_base::left,ios_base::adjustfield);
172 os << dat.fnc;
173
174 os << " | ";
175 os.setf(ios_base::left,ios_base::adjustfield);
176 os << dat.lib;
177
178 os << endl;
179
180 }
181
182 info() << endl << os.str() << endmsg;
183
184 }
std::ostringstream::setf
T setf(T...args)
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:124
std::endl
T endl(T...args)
StatusCodeSvc::m_dat
std::map< std::string, StatCodeDat > m_dat
Definition: StatusCodeSvc.h:45
std::ostringstream
STL class.
std::ostringstream::width
T width(T...args)
std::ostringstream::str
T str(T...args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

void StatusCodeSvc::parseFilter | ( | const std::string & | str,
|  | std::string & | fnc,
|  | std::string & | lib
| ) |  |
| private

Definition at line 213 of file StatusCodeSvc.cpp.

213 {
214
215
216 auto loc = str.find("=");
217 if (loc == std::string::npos) {
218 fnc = str;
219 lib = "";
220 } else {
221 string key = str.substr(0,loc);
222 string val = str.substr(loc+1);
223
224 toupper(key);
225
226 if (key == "FCN" || key == "FNC") {
227 fnc = val;
228 lib.clear();
229 } else if (key == "LIB") {
230 fnc.clear();
231 lib = val;
232 } else {
233 fnc.clear();
234 lib.clear();
235
236 warning() << "ignoring unknown token in Filter: " << str
237 << endmsg;
238 }
239 }
240
241 }
CommonMessagingBase::warning
MsgStream & warning() const
shortcut for the method msgStream(MSG::WARNING)
Definition: CommonMessaging.h:121
std::string::clear
T clear(T...args)
std::string::find
T find(T...args)
std::string::substr
T substr(T...args)
toupper
void toupper(std::string &s)
Definition: StatusCodeSvc.cpp:10
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

void StatusCodeSvc::regFnc | ( | const std::string & | func,
|  | const std::string & | lib
| ) |  |
| override

Definition at line 97 of file StatusCodeSvc.cpp.

97 {
98
99 if (m_state == Gaudi::StateMachine::OFFLINE ||
100 m_state == Gaudi::StateMachine::CONFIGURED) {
101 return;
102 }
103
104 if (m_dict &&
105 (lib.compare(lib.length()-7, 7, "Dict.so") == 0 ||
106 lib.compare(lib.length()-8, 8, "Cling.so") == 0)) {
107 return;
108 }
109 // this appears only with gcc 4.9...
110 if (fnc == "_PyObject_GC_Malloc") return;
111 // GAUDI-1036
112 if (fnc == "PyThread_get_thread_ident") return;
113 if (fnc == "local") return;
114
115 {
116 const string rlib = lib.substr(lib.rfind("/") + 1);
117
118 if (m_filterfnc.find(fnc) != m_filterfnc.end() ||
119 m_filterlib.find(rlib) != m_filterlib.end() ) {
120 return;
121 }
122 }
123
124 if (m_abort) {
125 fatal() << "Unchecked StatusCode in " << fnc << " from lib "
126 << lib << endmsg;
127 abort();
128 }
129
130 string key = fnc + lib;
131
132 auto itr = m_dat.find(key);
133
134 if (itr != m_dat.end()) {
135 itr->second.count += 1;
136 } else {
137
138 const string rlib = lib.substr(lib.rfind("/") + 1);
139
140 StatCodeDat dat;
141 dat.fnc = fnc;
142 dat.lib = rlib;
143 dat.count = 1;
144
145 m_dat[key] = dat;
146 }
147
148 }
StatusCodeSvc::m_abort
BooleanProperty m_abort
Definition: StatusCodeSvc.h:43
Gaudi::StateMachine::CONFIGURED
Definition: StateMachine.h:14
Service::m_state
Gaudi::StateMachine::State m_state
Service state.
Definition: Service.h:311
StatusCodeSvc::m_dict
BooleanProperty m_dict
Definition: StatusCodeSvc.h:43
std::string::rfind
T rfind(T...args)
std::set::end
T end(T...args)
StatusCodeSvc::m_dat
std::map< std::string, StatCodeDat > m_dat
Definition: StatusCodeSvc.h:45
StatusCodeSvc::m_filterfnc
std::set< std::string > m_filterfnc
Definition: StatusCodeSvc.h:46
std::set::find
T find(T...args)
std::string::length
T length(T...args)
std::string::substr
T substr(T...args)
std::abort
T abort(T...args)
CommonMessagingBase::fatal
MsgStream & fatal() const
shortcut for the method msgStream(MSG::FATAL)
Definition: CommonMessaging.h:112
Gaudi::StateMachine::OFFLINE
Definition: StateMachine.h:13
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
std::string::compare
T compare(T...args)
StatusCodeSvc::m_filterlib
std::set< std::string > m_filterlib
Definition: StatusCodeSvc.h:46

StatusCode StatusCodeSvc::reinitialize | ( |  | ) |
| override

Definition at line 63 of file StatusCodeSvc.cpp.

63 {
64
65 info() << "reinitialize" << endmsg;
66
67 return StatusCode::SUCCESS;
68
69 }
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:124
StatusCode::SUCCESS
Definition: StatusCode.h:30
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

bool StatusCodeSvc::suppressCheck | ( |  | ) | const
| inline override

Definition at line 23 of file StatusCodeSvc.h.

23 { return m_suppress.value() ; }
StatusCodeSvc::m_suppress
BooleanProperty m_suppress
Definition: StatusCodeSvc.h:43
PropertyWithValue::value
const TYPE & value() const
explicit conversion
Definition: Property.h:341

## Member Data Documentation

BooleanProperty StatusCodeSvc::m_abort
| private

Definition at line 43 of file StatusCodeSvc.h.

std::map<std::string,StatCodeDat> StatusCodeSvc::m_dat
| private

Definition at line 45 of file StatusCodeSvc.h.

BooleanProperty StatusCodeSvc::m_dict
| private

Definition at line 43 of file StatusCodeSvc.h.

std::set<std::string> StatusCodeSvc::m_filterfnc
| private

Definition at line 46 of file StatusCodeSvc.h.

std::set<std::string> StatusCodeSvc::m_filterlib
| private

Definition at line 46 of file StatusCodeSvc.h.

StringArrayProperty StatusCodeSvc::m_pFilter
| private

Definition at line 42 of file StatusCodeSvc.h.

BooleanProperty StatusCodeSvc::m_suppress
| private

Definition at line 43 of file StatusCodeSvc.h.

The documentation for this class was generated from the following files:

- GaudiCommonSvc/src/StatusCodeSvc.h
- GaudiCommonSvc/src/StatusCodeSvc.cpp